#include <stdio.h>
#include <stdlib.h>

#define DING    5
#define BOTTEL  7

/* hulpfunctie */
int hoeveelkeer(int wat,int getal)
{
        int resultaat;

        /* deelbaar door `wat'? */
        if (getal%wat == 0) resultaat = 1;
        else resultaat = 0;
        /* hoeveel keer komt er het cijfer `wat' in voor? */
        while (getal != 0) {
                /* het laatste cijfer is  getal%10 */
                if (getal%10 == wat) resultaat = resultaat + 1;
                /* knip het laatste cijfer eraf */
                getal = getal / 10;
        }
        return resultaat;
}

/* hoeveel keer moet er `ding' gezegd worden voor dit getal? */
int hoeveelding(int getal)
{
        return hoeveelkeer(DING,getal);
}

int hoeveelbottel(int getal)
{
        return hoeveelkeer(BOTTEL,getal);
}

/* druk een letter een aantal keer af
 * bv. drukzoveel(5,'*') drukt vijf sterretjes */
void drukzoveel(int aantal, int letter)
{
        while (aantal > 0) {
                putchar(letter);
                aantal = aantal - 1;
        }
}

void computerzegt(int getal)
{
        int dings;
        int bottels;

        dings = hoeveelding(getal);
        bottels = hoeveelbottel(getal);
        if (dings == 0) {
                if (bottels == 0) {
                        /* geen dings, geen bottels,
                         * gewoon het getalletje zeggen */
                        printf("%d\n",getal);
                        return;
                }
        }
        /* in het andere geval zijn er dings en/of bottels */
        drukzoveel(dings,'d');
        drukzoveel(bottels,'b');
        putchar('\n');
}

/* Lees wat de speler zegt.
 * Geeft 1 terug als het antwoord OK was */
int spelerzegt(int getal)
{
        char invoer[80];   /* de invoer van de speler */
        int dings;
        int bottels;
        int spelerdings;
        int spelerbottels;
        int tel;

        dings = hoeveelding(getal);
        bottels = hoeveelbottel(getal);
        gets(invoer);

        /* Kijk eerst of het aantal dings en bottels klopt */
        spelerdings = 0;
        spelerbottels = 0;
        for (tel = 0;  invoer[tel] != 0;  tel = tel + 1) {
                switch (invoer[tel]) {
                case 'b': spelerbottels = spelerbottels + 1;
                          break;
                case 'd': spelerdings = spelerdings + 1;
                          break;
                }
        }
        /* Vergelijk met de juiste aantallen */
        if (dings != spelerdings) return 0;
        if (bottels != spelerbottels) return 0;

        /* Aantallen dings en bottels kloppen.
         * Nu eventueel controleren of het getal juist is.
         * Dat moet natuurlijk alleen als dings==0 en bottels==0 */
        if (dings != 0) return 1;
        if (bottels != 0) return 1;
        /* Geen dings, geen bottels. Dus moet het antwoord een getal zijn */
        if (atoi(invoer) == getal) return 1;
        else return 0;
}

int main(void)
{
        int getal;

        getal = 1;
        while (1) {
                /* Om de beurt de computer ... */
                computerzegt(getal);
                getal = getal + 1;
                /* ... en de speler laten spelen */
                if (spelerzegt(getal) != 1) break;
                getal = getal + 1;
        }
        printf("Jammer ... het was: ");
        computerzegt(getal);
        return 0;
}
