#include <stdio.h>

#define BYTESPERREGEL 16

/* Druk de hexadecimale code van een getal tussen 0 en 15 */
void printh(int getal) {
       if (getal < 10) putchar('0'+getal);
       else putchar('A' + (getal-10) );
}

/* Druk de hexadecimale code van een byte af */
void printhex(unsigned char b) {
        printh(b >> 4);
        printh(b & 15);
}

/* Druk 'aantal' bytes af. */
void drukregel(unsigned char *bytes,int aantal)
{
        int tel;
        if (aantal == 0) return;

        /* Eerst de hexadecimale voorstelling */
        for (tel = 0; tel < BYTESPERREGEL; tel++) {
                if (tel < aantal) printhex(bytes[tel]);
                else printf("  ");
                /* Elke 4 bytes een spatie laten */
                if ((tel % 4) == 3) putchar(' ');
        }
        /* Ascii-voorstelling */
        printf("  ");
        for (tel = 0; tel < aantal; tel++) {
                unsigned char byte = bytes[tel];
                if (byte>=32 && byte<=126) putchar(byte);
                else putchar('.');
        }
        putchar('\n');
}

int main(void)
{
        unsigned char bytes[BYTESPERREGEL];
        int positie = 0;  /* volgende letter komt in
                           * bytes[positie] */

        while (1) {
                int byte = getchar();
                if (byte == EOF) break;
                bytes[positie++] = byte;
                if (positie == BYTESPERREGEL) {
                        /* In bytes[] zit een volle regel */
                        drukregel(bytes,positie);
                        positie = 0;
                }
        }
        /* Eventueel laatste regel afdrukken */
        drukregel(bytes,positie);
        return 0;
}
