#include <stdio.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <stdlib.h>     /* voor atoi() */

int main(int argc,char **argv)
{
        int poort = 4000;
        int sock;
        int quiet = 0;

        /* Drie manieren van aanroepen: ofwel
         * netecho               (gebruik poort 4000)
         * netecho 1234          (gebruik poort 1234)
         * netecho 1234 quiet    (gebruik poort 1234 en antwoord niets
         *                        terug aan de client; schrijf enkel op
         *                        het scherm wat de client doorstuurt) */
        if (argc >= 2) poort = atoi(argv[1]);
        if (argc >= 3) {
                if (!strcmp(argv[2],"quiet")) quiet = 1;
        }

        sock = socket(AF_INET,SOCK_STREAM,0);
        {       /* poort van de socket instellen */
                struct sockaddr_in adres;

                adres.sin_family = AF_INET;
                adres.sin_addr.s_addr = INADDR_ANY;
                adres.sin_port = htons(poort);
                if (bind(sock,(struct sockaddr *)&adres,sizeof(adres))<0) {
                        puts("bind error");
                        return 10;
                }
        }

        /* begin te luisteren naar clients die een verbinding willen */
        if (listen(sock,5)< 0) {
                puts("listen error");
                return 11;
        }

        while (1) {
                struct sockaddr_in client;
                int clientSock;
                char regel[255];
                FILE *klant;
                int clientlen = sizeof(client);

                printf("Wacht op verbindingen op poort %d ...\n",poort);
                clientSock = accept(sock,(struct sockaddr *)&client,&clientlen);
                puts("Een klant! Een klant!");
                klant = fdopen(clientSock,"r+");
                setbuf(klant,NULL);
                while (fgets(regel,sizeof(regel),klant)) {
                        if (!quiet) fprintf(klant,"Je zei: %s",regel);
                        printf(">\t%s",regel);
                }
                /* client heeft de verbinding verbroken */
                fclose(klant);
        }

        return 0;
}
