/* bepaal precisie van een floating point datatype */
#include <math.h>
#include <stdio.h>

#define TYPE long double
#define FORMAT "%.60Le"		/* %.60e of %.60Le */

/* verkleinen in abs waarde tot het niet meer gaat */
TYPE kleinste(TYPE f)
{
	while (1) {
		TYPE g = f * .5;

		if (f==g || g==0) break;
		f = g;
	}
	/* f is nu zeer klein; f/2 == 0 */
	while (1) {
		TYPE g = f * .99999;

		if (f==g || g==0) break;
		f = g;
	}
	return f;
}

/* vergroten in abs waarde tot het niet meer gaat */
/* overflow detect door Inf==Inf */
TYPE grootste(TYPE f)
{
	TYPE erbij;
	while (1) {
		TYPE g = f * 2;

		if (f==g || g*2==g) break;
		f = g;
	}
	/* f is nu zeer groot; 2*f == oneindig */
	erbij = f;
	while (1) {
		TYPE g;

		erbij *= 0.5;
		g = f + erbij;
		if (f==g || g*2==g) break;
		f = g;
	}
	return f;
}

TYPE precisie(void)
{
	TYPE f = 1.0;
	TYPE eps = 1.0;

	while (1) {
		TYPE g = f + eps;

		if (g == f) break;
		eps *= 0.5;
	}

	while (1) {
		TYPE g = f + eps;

		if (g == f) break;
		eps *= 0.99999;
	}
	return -log10(eps);
}

void main(void)
{
	printf("Kleinste:\n\t " FORMAT "\n\t" FORMAT "\n",
		kleinste(1.0),kleinste(-1.0));
	printf("Grootste:\n\t " FORMAT "\n\t" FORMAT "\n",
		grootste(1.0),grootste(-1.0));
	printf("Precisie in decimalen:\n\t " FORMAT "\n",precisie());
	printf("Bits: %d\n",sizeof(TYPE)*8);
}
