#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>

struct Woord {
        struct Woord *next;
        char *van;
        char *naar;
};

struct Woord *leeswoorden(char *fnaam) {
        struct Woord *result = NULL;
        char lijn[255];
        FILE *wdb = fopen(fnaam,"r");
        if (!wdb) return NULL;
        while(fgets(lijn,sizeof(lijn),wdb)) {
                struct Woord *nieuw = malloc(sizeof(struct Woord));
                char *split = strstr(lijn,"\t");
                char *end = lijn + strlen(lijn)-1;        /* points to \n */
                if (!split) continue;
                nieuw->next = result;
                result = nieuw;
                nieuw->van = malloc(split-lijn+1);
                strncpy(nieuw->van,lijn,split-lijn);
                nieuw->van[split-lijn] = 0;
                split++;
                nieuw->naar = malloc(end-split+1);
                strncpy(nieuw->naar,split,end-split);
                nieuw->naar[end-split] = 0;
        }
        fclose(wdb);
        return result;
}

/* Druk de vertaling van het woord af */
void vertaalwoord(char *woord,struct Woord *woordenlijst) {
        struct Woord *snuffel;
        for (snuffel = woordenlijst; snuffel; snuffel = snuffel->next) {
                if (!strcasecmp(snuffel->van,woord)) {
                        /* hoe staat het originele woord er? */
                        if (islower(*woord)) {        /* kleine letters */
                                printf("%s",snuffel->naar);
                        } else if (isupper(woord[1])) {        /* HOOFDLETTERS */
                                char *walk;
                                for (walk = snuffel->naar; *walk; walk++)
                                        putchar(toupper(*walk));
                        } else {        /* Gekapitaliseerd */
                                printf("%c%s",toupper(snuffel->naar[0]),snuffel->naar+1);
                        }
                        return;
                }
        }
        /* geen vertaling gevonden in woordenboek ... */
        printf("%s",woord);
}

int main(int argc,char **argv) {
	struct Woord *woordenlijst;

        woordenlijst = leeswoorden("woordenlijst");
        while (1) {
                char woord[255];

                printf("woord: "); fflush(stdout);
                gets(woord);
                if (woord[0] == 0) break;
                printf("vertaling: ");
                vertaalwoord(woord,woordenlijst);
		putchar('\n');
        }
        return 0;
}
